import java.awt.*;
import java.awt.event.*;
import java.util.Locale;

/**
 * w肳ꂽԂo߂Ƃ[Uɒʒm郁bZ[WEB
 * hE.
 */
public class TimMessageWindow extends Frame
								implements ActionListener{
	private Tim tim; /* AvP[ṼCIuWFNg */
	private Label msg; /* EBhEɕ\郁bZ[W */
	private ImageArea imageArea; /* C[W\̈ */
	
	/* OK{^ */
	private Button okButton = new Button("   OK   ");
	
	private Panel row1;   /* 1sڂ̃R|[lgpl */
	private Panel row2;   /* 2sڂ̃R|[lgpl */
	private Point winPos; /* EBhE\ʒu */
	
	
	/**
	 * bZ[WEBhE𐶐.
	 *
	 * @param tim       AvP[ṼCIuWFNg.
	 * @param image     EBhEɕ\C[W.
	 * @param imgWidth  EBhEɕ\C[W̕.
	 * @param imgHeight EBhEɕ\C[W̍.
	 */
	public TimMessageWindow(
		Tim tim, Image image, int imgWidth, int imgHeight
	){
		super("Tim: Message");
		
		this.tim = tim;
		
		imageArea = new ImageArea(image);
		imageArea.setSize(imgWidth, imgHeight);
		
		setLocale(Locale.JAPANESE);
		
		msg = new Label("Ԃł");
		
		row1 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row1.add(imageArea);
		row1.add(msg);
		
		row2 = new Panel(new FlowLayout(FlowLayout.CENTER));
		row2.add(okButton);
		okButton.addActionListener(this);
		
		add("Center", row1);
		add("South" , row2);
		
		pack();
		
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		
		/* ʃTCY擾 */
		Dimension scrSize = toolkit.getScreenSize();
		
		/* EBhE̕\ʒuʂ̒ɐݒ */
		winPos = new Point();
		winPos.x = scrSize.width / 2 - getSize().width / 2;
		winPos.y = scrSize.height / 2 - getSize().height / 2;
		
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	}
	
	/**
	 * EBhECxg.
	 * (EBhE鎞̃Cxĝ݂)
	 */
	public void processWindowEvent(WindowEvent e){
		if(e.getID() == WindowEvent.WINDOW_CLOSING){
			setVisible(false);
			tim.stopAlerting();
		}
		
		super.processWindowEvent(e);
	}
	
	/**
	 * OK{^ꂽ̏s.
	 */
	public void actionPerformed(ActionEvent e){
		if(e.getSource().equals(okButton)){
			setVisible(false);
			tim.stopAlerting();
		}
	}
	
	/**
	 * EBhE̕\/\؂ւ.
	 *
	 * @param b EBhE\ꍇtrue, \Ȃꍇ
	 *          false.
	 */
	public void setVisible(boolean b){
		if(b == true){
			setLocation(winPos);
		}
		
		super.setVisible(b);
	}
}


/*
 * C[W\̈.
 */
class ImageArea extends Canvas{
	Image image;
	
	ImageArea(Image image){
		this.image = image;
	}
	
	public void paint(Graphics g){
		g.drawImage(image, 0, 0, this);
	}
}