import java.awt.*;
import java.awt.event.*;

/**
 * AvP[V̐ݒsEBhE.
 * <p>
 * EBhEOK{^NbN,ݒEBhEIuWFNg
 * ,w莞Ԃo߂Ƃ̒ʒm@̑Ie(A[ɂʒm
 * ǂƂIe)AvP[ṼCIuWFNg
 * ɒʒm. ܂,ʒms܂ł̎ԂуJEg[h̑I
 * e^C}[ǗIuWFNgɒʒm.
 * </p>
 */
public class TimSettingWindow extends Frame
								implements ActionListener{
	/* AvP[ṼCIuWFNg */
	private Tim tim;
	
	/*
	 * ^C}[ԓ͗̈̕񂪐Ȃꍇɕ\G[
	 * _CAO
	 */
	private TimErrorDialog errorDialog;
	
	/*
	 * EBhE͐ɕꂽ̗̈悩\,Ẍ̗
	 * ɂ͂̃R|[lgɔzu.
	 * ȉ̃IuWFNg,ꂽẌ̗(nsڂ̗̈)\.
	 */
	private Panel row1;
	private Panel row2;
	private Panel row3;
	private Panel row4;
	private Panel row5;
	private Panel row6;
	private Panel row7;
	private Panel row8;
	
	/* 1sڂ̃R|[lg */
	private Checkbox countDownCb = new Checkbox("Count Down Mode");
	
	/* 2sڂ̃R|[lg */
	private Label row2msg = new Label("Alert After");
	
	/*
	 * 3sڂ̃R|[lg.
	 *
	 * ʒms܂ŎԂݒ肷邽߂̓͗̈Ƃ̉ɕ\
	 * .
	 */
	private TextField hourField  = new TextField("0", 2);
	private Label hourLabel = new Label("hours");
	private TextField minuteField = new TextField("0", 2);
	private Label minuteLabel = new Label("minutes");
	private TextField secondField = new TextField("0", 2);
	private Label secondLabel = new Label("seconds");
	
	/* 4sڂ̃R|[lg */
	private Label row4msg = new Label("Alert By");
	
	/* 5sڂ̃R|[lg */
	private Checkbox alarmCb = new Checkbox("Alarm");
	
	/* 6sڂ̃R|[lg */
	private Checkbox messageCb = new Checkbox("Message Window");
	
	/* 7sڂ̃R|[lg */
	private Checkbox blinkCb = new Checkbox("Display Blinking");
	
	/* 8sڂ̃R|[lg */
	private Panel buttonPanel = new Panel(new GridLayout(1, 2, 7, 0));
	private Button okButton = new Button("OK");
	private Button cancelButton = new Button("Cancel");
	
	
	/*
	 * e`FbN{bNX,eLXg͗̈̒lۑĂ߂
	 * ϐ.
	 * Cancel{^ꂽ,̒lɖ߂߂ɂ̕ϐɕ
	 * Ălgp.
	 */
	
	/* Ԃ͂̈̕ */
	private String  hourFieldStr;
	
	/* ͂̈̕ */
	private String  minuteFieldStr;
	
	/* b͂̈̕ */
	private String  secondFieldStr;
	
	/*
	 * A[ɂʒmsǂI`FbN{bNX
	 * l.
	 */
	private boolean alarmCbValue;
	
	/*
	 * bZ[W_CAO̕\ɂʒmsǂI
	 * `FbN{bNX̒l.
	 */
	private boolean messageCbValue;
	
	/*
	 * fBXvC̓_ŕ\ɂʒmsǂI
	 * `FbN{bNX̒l.
	 */
	private boolean blinkCbValue;
	
	/*
	 * JEg_E[hɂ邩ǂI`FbN{bNX
	 * ̒l.
	 */
	private boolean countDownCbValue;
	
	
	/**
	 * AvP[V̐ݒEBhE𐶐.
	 *
	 * @param tim AvP[ṼCIuWFNg.
	 */
	public TimSettingWindow(Tim tim){
		this.tim = tim;
		
		errorDialog = new TimErrorDialog(this);
		
		row1 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row1.add(countDownCb);
		
		row2 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row2.add(row2msg);
		
		row3 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row3.add(hourField);
		row3.add(hourLabel);
		row3.add(minuteField);
		row3.add(minuteLabel);
		row3.add(secondField);
		row3.add(secondLabel);
		
		row4 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row4.add(row4msg);
		
		row5 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row5.add(alarmCb);
		
		row6 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row6.add(messageCb);
		
		row7 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row7.add(blinkCb);
		
		row8 = new Panel(new FlowLayout(FlowLayout.CENTER));
		buttonPanel.add(okButton);
		buttonPanel.add(cancelButton);
		row8.add(buttonPanel);
		
		okButton.addActionListener(this);
		cancelButton.addActionListener(this);
		
		setLayout(new GridLayout(8, 1));
		
		add(row1);
		add(row2);
		add(row3);
		add(row4);
		add(row5);
		add(row6);
		add(row7);
		add(row8);
		
		pack();
		
		setTitle("Tim Setting Window");
		
		/*
		 * AvbgƂĎsĂȂꍇ̓A[ʒm̐ݒ
		 * gpsɂ.
		 */
		if(!tim.isRunningAsApplet()){
			alarmCb.setEnabled(false);
		}
		
		/* WindowCxg */
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	}
	
	/**
	 * EBhECxg.
	 * (EBhE鎞̃Cxĝ݂)
	 */
	public void processWindowEvent(WindowEvent e){
		if(e.getID() == WindowEvent.WINDOW_CLOSING){
			/* Cancel{^ꂽꍇƓl̏s */
			cancelButtonPressed();
		}
		
		super.processWindowEvent(e);
	}
	
	/**
	 * {^ꂽ̏s.
	 */
	public void actionPerformed(ActionEvent e){
		if(e.getSource().equals(okButton)){ /* OK{^ */
			okButtonPressed();
		}else if(e.getSource().equals(cancelButton)){ /* Cancel{^ */
			cancelButtonPressed();
		}
	}
	
	/**
	 * EChE̕\/\؂ւ.
	 *
	 * @param b EBhE\ꍇtrue,\Ȃꍇfalse.
	 */
	public void setVisible(boolean b){
		if(b == true){
			/*
			 * ݂̃AvP[V̐ݒ擾,EBhE
			 * ̃`FbN{bNXƃeLXg͗̈̒lɔf
			 * .
			 */
			alarmCb.setState(tim.getAlertByAlarm());
			messageCb.setState(tim.getAlertByMessage());
			blinkCb.setState(tim.getAlertByBlink());
			
			TimeCounter counter = tim.getTimeCounter();
			
			if(counter.isCountDownMode()){
				countDownCb.setState(true);
			}else{
				countDownCb.setState(false);
			}
			
			TimTime alertTime = counter.getAlertTime();
			
			hourField.setText(
				String.valueOf(alertTime.get(TimTime.HOUR))
			);
			
			minuteField.setText(
				String.valueOf(alertTime.get(TimTime.MINUTE))
			);
			
			secondField.setText(
				String.valueOf(alertTime.get(TimTime.SECOND))
			);
			
			saveValues();
			suppressScreenOut();
		}
		
		super.setVisible(b);
	}
	
	/*
	 * EBhEʂ͂ݏoȂ悤ɕ\ʒu𒲐.
	 */
	private void suppressScreenOut(){
		/* ʂ̑傫擾 */
		Toolkit toolkit = Toolkit.getDefaultToolkit();
		Dimension scrSize = toolkit.getScreenSize();
		
		/* ̃EBhĚ݈ʒu擾 */
		Point p = getLocation();
		
		/* ̃EBhȆ傫擾 */
		Dimension winSize = getSize();
		
		/* Eɂ͂ݏoĂ邩ǂ */
		if(scrSize.width < (p.x + winSize.width)){
			p.x = scrSize.width - winSize.width;
		}
		
		/* ɂ͂ݏoĂ邩ǂ */
		if((scrSize.height - 28) < (p.y + winSize.height)){
			p.y = (scrSize.height - 28) - winSize.height;
		}
		
		setLocation(p.x, p.y);
	}
	
	/*
	 * OK{^ꂽ̏s.
	 */
	private void okButtonPressed(){
		/*
		 * ʒms܂ł̎Ԃ͂̈ɓ͂ꂽ
		 * G[Ȃǂ`FbN.
		 */
		try{
			checkInputedTime();
		}catch(NumberFormatException e){
			return;
		}
		
		setVisible(false); /* EBhE */
		
		/*
		 * AvP[V̐ݒ,݂̊e`FbN{bNX̒l,
		 * eLXg͗̈̓e𔽉f悤ɍXV.
		 */
		tim.setAlertByAlarm(alarmCb.getState());
		tim.setAlertByMessage(messageCb.getState());
		tim.setAlertByBlink(blinkCb.getState());
		
		TimeCounter counter = tim.getTimeCounter();
		
		int hour = getIntValue(hourField.getText());
		int minute = getIntValue(minuteField.getText());
		int second = getIntValue(secondField.getText());
		
		if(countDownCb.getState() == true){
			counter.alertAfter(
				hour, minute, second, TimeCounter.COUNT_DOWN
			);
		}else{
			counter.alertAfter(
				hour, minute, second, TimeCounter.NORMAL
			);
		}
	}
	
	/*
	 * Cancel{^ꂽ̏s.
	 */
	private void cancelButtonPressed(){
		setVisible(false); /* EBhE */
		restoreValues();   /* `FbN{bNXȂǂ̒lɖ߂ */
	}
	
	/*
	 * ݂̊e`FbN{bNX̒l,eLXg͗̈̕ۑ
	 * .
	 */
	private void saveValues(){
		countDownCbValue = countDownCb.getState();
		alarmCbValue = alarmCb.getState();
		messageCbValue = messageCb.getState();
		blinkCbValue = blinkCb.getState();
		
		hourFieldStr = hourField.getText();
		minuteFieldStr = minuteField.getText();
		secondFieldStr = secondField.getText();
	}
	
	/*
	 * ݂̊e`FbN{bNX̒l,eLXg͗̈̕
	 * <code>saveValues()</code>ɂĕۑꂽlɖ߂.
	 */
	private void restoreValues(){
		countDownCb.setState(countDownCbValue);
		alarmCb.setState(alarmCbValue);
		messageCb.setState(messageCbValue);
		blinkCb.setState(blinkCbValue);
		
		hourField.setText(hourFieldStr);
		minuteField.setText(minuteFieldStr);
		secondField.setText(secondFieldStr);
	}
	
	/*
	 * ʒms܂ł̎Ԃ͂̈ɓ͂ꂽ񂪑Ó
	 * 邩ǂ`FbN.
	 */
	private void checkInputedTime() throws NumberFormatException{
		Point winPos = getLocationOnScreen();
		Dimension winSize = getSize();
		
		Point dialogPos;
		Dimension dialogSize = errorDialog.getSize();
		
		/*
		 * G[ɕ\_CAÖʒuݒ肷.
		 * (̃EBhE̒ɕ\)
		 */
		dialogPos = new Point(
			winPos.x + (winSize.width / 2 - dialogSize.width / 2),
			winPos.y + (winSize.height / 2 - dialogSize.height / 2)
		);
		
		errorDialog.setLocation(dialogPos);
		
		/* ԓ͗̈ɓ͂ꂽl */
		int hour, minute, second;
		
		/* tH[}bg`FbN */
		try{
			hour = Integer.parseInt(hourField.getText());
			
		}catch(NumberFormatException e){
			errorDialog.setErrorField(
				TimErrorDialog.HOUR, hourField.getText()
			);
			errorDialog.setVisible(true);
			
			throw e;
		}
		
		/* l͈̔͂`FbN */
		if(hour < 0 || 99 < hour){ /* ÓȔ͈͊O */
			errorDialog.setErrorField(
				TimErrorDialog.HOUR, hourField.getText()
			);
			errorDialog.setVisible(true);
			
			throw new NumberFormatException();
		}
		
		/* ȉlɕAb`FbN */
		
		try{
			minute = Integer.parseInt(minuteField.getText());
			
		}catch(NumberFormatException e){
			errorDialog.setErrorField(
				TimErrorDialog.MINUTE, minuteField.getText()
			);
			errorDialog.setVisible(true);
			
			throw e;
		}
		
		if(minute < 0 || 59 < minute){
			errorDialog.setErrorField(
				TimErrorDialog.MINUTE, minuteField.getText()
			);
			errorDialog.setVisible(true);
			
			throw new NumberFormatException();
		}
		
		try{
			second = Integer.parseInt(secondField.getText());
			
		}catch(NumberFormatException e){
			errorDialog.setErrorField(
				TimErrorDialog.SECOND, secondField.getText()
			);
			errorDialog.setVisible(true);
			
			throw e;
		}
		
		if(second < 0 || 59 < second){
			errorDialog.setErrorField(
				TimErrorDialog.SECOND, secondField.getText()
			);
			errorDialog.setVisible(true);
			
			throw new NumberFormatException();
		}
	}
	
	/*
	 * ʒms܂ł̎Ԃ͂̈ɓ͂ꂽ𐮐l
	 * ɕϊ.
	 *
	 * @param s ϊ镶.
	 *
	 * @return  ϊꂽl.
	 */
	private int getIntValue(String s){
		try{
			return Integer.parseInt(s);
		}catch(NumberFormatException e){ /* ɕϊłȂ */
			return 0;
		}
	}
}


/*
 * ԓ͗̈̕񂪐lłȂꍇɕ\G[_CA
 * O
 */
class TimErrorDialog extends Dialog implements ActionListener{
	/* G[̂͗̈\萔 */
	static final int HOUR   = 0;
	static final int MINUTE = 1;
	static final int SECOND = 2;
	
	/*
	 * G[̂̈.
	 * 3̒萔̂ꂩi[.
	 */
	private int errorField;
	
	private String errorStr; /* ͂ꂽG[ */
	
	/* nsڂ̃R|[lgpl */
	private Panel  row1;
	private Panel  row2;
	private Panel  row3;
	
	private Label  row1msg = new Label(
		"Illegal ******: **********************"
	);
	
	private Label  row2msg = new Label(
		"******* must be a number between 0 and 00."
	);
	
	private Button okButton = new Button("   OK   ");
	
	
	/*
	 * G[_CAO𐶐.
	 */
	TimErrorDialog(Frame f){
		super(f, "Tim: Error", false);
		
		row1 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row1.add(row1msg);
		
		row2 = new Panel(new FlowLayout(FlowLayout.LEFT));
		row2.add(row2msg);
		
		row3 = new Panel(new FlowLayout(FlowLayout.CENTER));
		row3.add(okButton);
		okButton.addActionListener(this);
		
		setLayout(new GridLayout(3, 1));
		
		add(row1);
		add(row2);
		add(row3);
		
		pack();
		
		/* WindowCxg */
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
	}
	
	/*
	 * G[̂͗̈ݒ肷.
	 *
	 * @param field G[̂͗̈\萔.
	 * @param str   ͂ꂽG[.
	 */
	void setErrorField(int field, String str){
		errorField = field;
		errorStr = str;
	}
	
	/*
	 * OK{^ꂽ̏s.
	 */
	public void actionPerformed(ActionEvent e){
		if(e.getSource().equals(okButton)){
			setVisible(false);
		}
	}
	
	/*
	 * EBhECxg.
	 * (EBhE鎞̃Cxĝ݂)
	 */
	public void processWindowEvent(WindowEvent e){
		if(e.getID() == WindowEvent.WINDOW_CLOSING){
			setVisible(false);
		}
		
		super.processWindowEvent(e);
	}
	
	/*
	 * _CAO̕\/\؂ւ.
	 * _CAO\ꍇ,G[̂͗̈ɂĕ\
	 * 郁bZ[WύX.
	 */
	public void setVisible(boolean b){
		if(b == true){ /* _CAO\ꍇ */
			if(errorField == HOUR){
				row1msg.setText("Illegal hour: " + errorStr);
				
				row2msg.setText(
					"Hour must be a number between 0 and 99."
				);
				
			}else if(errorField == MINUTE){
				row1msg.setText("Illegal minute: " + errorStr);
				
				row2msg.setText(
					"Minute must be a number between 0 and 59."
				);
				
			}else if(errorField == SECOND){
				row1msg.setText("Illegal second: " + errorStr);
				
				row2msg.setText(
					"Second must be a number between 0 and 59."
				);
				
			}else{
				return;
			}
		}
		
		super.setVisible(b);
	}
}