/*
 * Tim Version 1.2   2001/04/14
 *
 * Copyright (C) 1999-2001  Otaki Shinya.  All Rights Reserved.
 */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
 * AvP[ṼCNX.
 * <p>
 * AvP[V\IuWFNg̊Ǘ,уAvP[V
 * ̓̐s.
 * AvP[V\vȃIuWFNgɂ͈ȉ̂̂.
 * </p>
 * <ul>
 * <li>AvP[ṼfBXvC(<code>TimDisplay</code>).
 * <li>^C}[ǗIuWFNg(<code>TimeCounter</code>).
 * <li>AvP[V̐ݒEBhE
 *     (<code>TimSettingWindow</code>).
 * <li>w肳ꂽԂo߂Ƃɕ\郁bZ[W_CAO
 *     (<code>TimMessageWindow</code>).
 * <li>AvP[V̓̐s{^.
 * </ul>
 * <p>
 * ̃CNXł,̃IuWFNg̐s.
 * ܂,IuWFNgmbZ[WƂ肷ۂ̒s.
 * Ⴆ,[UݒEBhEŒʒms܂ł̎ԂύX
 * ꍇ,ݒEBhEIuWFNg,̃NX
 * <code>getTimeCounter()</code>\bhɂ,^C}[ǗIu
 * WFNgւ̎QƂ擾.
 * ,ꂽQƂʂ,ݒ肳ꂽԂ^C}[ǗIuWF
 * Ngɒʒm.
 * </p>
 */
public class Tim extends Applet implements ActionListener{
	/* oߎԂȂǂ̏\邽߂̃fBXvC */
	private TimDisplay display;
	
	/* ԕ\̍XVsIuWFNg */
	private TimeCounter counter;
	
	/* A[TEh */
	private AudioClip alarm = null;
	
	/* ̃AvP[V̐ݒs߂̃EBhE */
	private TimSettingWindow settingWindow;
	
	/* w肳ꂽԂo߂Ƃʒm邽߂̃EBhE */
	private TimMessageWindow messageWindow;
	
	/* ̃AvP[VŎgp{^ */
	private Button startButton;   // ^C}[X^[g{^
	private Button stopButton;    // ^C}[Xgbv{^
	private Button resetButton;   // ^C}[Zbg{^
	private Button settingButton; // ݒEBhEĂяo{^
	
	/* X^[g,Xgbv,Zbg{^邽߂̃pl */
	private Panel buttonPanel;
	
	/* w莞ɂȂ̒ʒm@ۑ */
	private boolean alertByAlarm   = false; // A[炷
	private boolean alertByMessage = false; // bZ[W̕\
	private boolean alertByBlink   = false; // fBXvC̓_ŕ\
	
	/* ݒʒmsĂŒǂ */
	private boolean alerting = false;
	
	/* AvbgƂĎsĂ邩ǂ */
	private boolean runningAsApplet = true;
	
	/*
	 * bZ[WEBhEɕ\C[W̃[hǗ
	 * IuWFNg.
	 */
	private MediaTracker tracker;
	
	
	/**
	 * AvP[V̏s.
	 */
	public void init(){
		/* R|[lg̃CAEgsIuWFNg𐶐 */
		GridBagLayout gridbag = new GridBagLayout();
		
		/* CAEg̒sIuWFNg𐶐 */
		GridBagConstraints gc = new GridBagConstraints();
		
		setLayout(gridbag);
		
		/* fBXvCIuWFNg𐶐,zu */
		display       = new TimNormalDisplay();
		gc.gridwidth  = GridBagConstraints.REMAINDER;
		gridbag.setConstraints((Component)display, gc);
		add((Component)display);
		
		/* {^pl𐶐 */
		buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(1, 3, 3, 0));
		
		/*
		 * {^𐶐,plɓ.
		 */
		startButton = new Button("Start");
		buttonPanel.add(startButton);
		
		stopButton = new Button("Stop");
		buttonPanel.add(stopButton);
		
		resetButton = new Button("Reset");
		buttonPanel.add(resetButton);
		
		/* {^plzu */
		gc.fill = GridBagConstraints.HORIZONTAL;
									// ςɐL΂
		gridbag.setConstraints(buttonPanel, gc);
		add(buttonPanel);
		
		/* Setting{^zu */
		gc.insets = new Insets(3, 0, 3, 0);
		settingButton = new Button("Setting");
		gridbag.setConstraints(settingButton, gc);
		add(settingButton);
		
		/*
		 * {^ꂽ̏sIuWFNgg
		 * ݒ.
		 */
		startButton.addActionListener(this);
		stopButton.addActionListener(this);
		resetButton.addActionListener(this);
		settingButton.addActionListener(this);
		
		/* ԕ\̍XVsIuWFNg𐶐 */
		counter = new TimeCounter(this);
		
		/* AvbgƂĎsĂ邩? */
		if(runningAsApplet){
			/* A[TEhݒ */
			alarm = getAudioClip(getCodeBase(), "alarm.au");
		}
		
		/* ݒEBhE𐶐 */
		settingWindow = new TimSettingWindow(this);
		
		/*
		 * bZ[WEBhEɕ\C[W[h.
		 */
		Image image;
		
		if(runningAsApplet){ // AvbgƂĎsĂ
			image = getImage(getCodeBase(), "image.gif");
		}else{
			image = Toolkit.getDefaultToolkit().getImage("image.gif");
		}
		
		tracker = new MediaTracker(this);
		tracker.addImage(image, 0);
		
		try{
			/* C[W̃[ĥ҂ */
			tracker.waitForID(0);
		}catch(InterruptedException e){
			/* Ȃ */
		}
		
		/* bZ[WEBhE𐶐 */
		messageWindow = new TimMessageWindow(this, image, 50, 40);
		
		/*
		 * AvP[VÑftHg̐ݒs.
		 */
		setAlertByBlink(true);   // ʂ̓_ŕ\ɂʒms
		setAlertByMessage(true); // bZ[WEBhEɂʒm
								 // s
		
		if(runningAsApplet){ // AvbgƂĎsĂꍇ
			setAlertByAlarm(true); // A[ɂʒms
		}
	}
	
	/**
	 * AvP[V̏Is.
	 */
	public void stop(){
		counter.stop();
		counter = null;
		
		if(alarm != null){
			alarm.stop();
		}
		
		settingWindow.dispose();
		
		messageWindow.dispose();
	}
	
	/**
	 * AvP[ṼfBXvCIuWFNg擾.
	 *
	 * @return AvP[ṼfBXvCIuWFNg.
	 */
	public TimDisplay getDisplay(){
		return display;
	}
	
	/**
	 * ^C}[ǗIuWFNg擾.
	 *
	 * @return ^C}[ǗIuWFNg.
	 */
	public TimeCounter getTimeCounter(){
		return counter;
	}
	
	/**
	 * AvbgƂĎsĂ邩ǂ𒲂ׂ.
	 *
	 * @return AvbgƂĎsĂꍇtrue, X^h
	 *         AAvP[VƂĎsĂꍇ
	 *         false.
	 */
	public boolean isRunningAsApplet(){
		return runningAsApplet;
	}
	
	/**
	 * w肳ꂽԂo߂Ƃ[Uɒʒm.
	 */
	public void alert(){
		if(alertByAlarm && (alarm != null)){
			alarm.loop();
		}
		
		if(alertByMessage){
			messageWindow.setVisible(true);
			messageWindow.toFront();
		}
		
		if(alertByBlink){
			display.blink();
		}
		
		alerting = true;
	}
	
	/**
	 * ʒm~.
	 */
	public void stopAlerting(){
		if(alarm != null){
			alarm.stop();
		}
		
		if(messageWindow.isShowing()){
			messageWindow.setVisible(false);
		}
		
		display.stopBlinking();
		
		alerting = false;
	}
	
	/**
	 * ݒʒmsĂŒǂ𒲂ׂ.
	 *
	 * @return ʒmsĂꍇtrue, łȂꍇfalse.
	 */
	public boolean isAlerting(){
		return alerting;
	}
	
	/**
	 * A[ɂʒmsǂw肷.
	 *
	 * @param b A[ɂʒmsꍇtrue, sȂꍇ
	 *          false.
	 */
	public void setAlertByAlarm(boolean b){
		alertByAlarm = b;
		display.setAlarmIndicator(b);
	}
	
	/**
	 * A[ɂʒmsݒɂȂĂ邩ǂ𒲂ׂ.
	 *
	 * @return A[ɂʒmsݒ̏ꍇtrue, łȂ
	 *         ꍇfalse.
	 */
	public boolean getAlertByAlarm(){
		return alertByAlarm;
	}
	
	/**
	 * bZ[WEBhE̕\ɂʒmsǂw肷.
	 *
	 * @param b bZ[WEBhE̕\ɂʒmsꍇtrue,
	 *          sȂꍇfalse.
	 */
	public void setAlertByMessage(boolean b){
		alertByMessage = b;
		display.setMessageIndicator(b);
	}
	
	/**
	 * bZ[WEBhE̕\ɂʒmsݒɂȂĂ邩
	 * ǂ𒲂ׂ.
	 *
	 * @return bZ[WEBhE̕\ɂʒmsݒ̏ꍇ
	 *         true, łȂꍇfalse.
	 */
	public boolean getAlertByMessage(){
		return alertByMessage;
	}
	
	/**
	 * fBXvC̓_ŕ\ɂʒmsǂw肷.
	 *
	 * @param b fBXvC̓_ŕ\ɂʒmsꍇtrue,
	 *          sȂꍇfalse.
	 */
	public void setAlertByBlink(boolean b){
		alertByBlink = b;
		display.setBlinkIndicator(b);
	}
	
	/**
	 * fBXvC̓_ŕ\ɂʒmsݒɂȂĂ邩ǂ
	 * 𒲂ׂ.
	 *
	 * @return fBXvC̓_ŕ\ɂʒmsݒ̏ꍇ
	 *         true, łȂꍇfalse.
	 */
	public boolean getAlertByBlink(){
		return alertByBlink;
	}
	
	/**
	 * {^ꂽ̏s.
	 */
	public void actionPerformed(ActionEvent evt){
		if(evt.getSource().equals(startButton)){ // Start{^
			/* ^CJEgX^[g */
			if(counter.isAlive()){
				counter.restart();
			}else{
				counter.start();
			}
			
		}else if(evt.getSource().equals(stopButton)){ // Stop{^
			/* ^CJEg~ */
			counter.pause();
			stopAlerting();
			
		}else if(evt.getSource().equals(resetButton)){ // Reset{^
			/* Zbg */
			counter.reset();
			counter.pause();
			stopAlerting();
			
		}else if(evt.getSource().equals(settingButton)){ // Setting
														 // {^
			/* ݒEBhE\ */
			if(settingWindow.isShowing()){
				settingWindow.toFront();
			}else{
				Point p = getLocationOnScreen();
				settingWindow.setLocation(p.x + 50, p.y + 70);
				settingWindow.setVisible(true);
			}
		}
	}
	
	/**
	 * X^hAAvP[VƂĎs鎞ɂ,̃\b
	 * hŏɌĂяoȂ΂ȂȂ.
	 */
	public void startAsApplication(){
		runningAsApplet = false;
		init();
	}
	
	/**
	 * X^hAAvP[VƂĎs,ŏɌĂ΂
	 * .
	 */
	public static void main(String args[]){
		Tim tim = new Tim();
		tim.startAsApplication();
		
		TimWindow window = new TimWindow(tim);
		window.add(tim);
		window.pack();
		
		/* R}hCŃEBhËʒuw肳ꂽ? */
		if(args.length == 2){
			/* EBhE\ʒuŎw肳ꂽʒuɕύX */
			window.setLocation(args[0], args[1]);
		}
		
		window.setVisible(true);
	}
}