import java.awt.*;

/**
 * AvP[V̕W̃fBXvC.
 * <p>
 * AvP[V̕W̃fBXvC͏㉺2̗̈悩\.
 * ̗̈ɂ͎w肳ꂽԂo߂,ǂ̂悤ȕ@Œʒms
 * \(Alarm, BlinkƂ)\. ̗̈
 * ݂͌̌oߎ(܂͎c莞)\.
 * </p>
 * <p>
 * \F<br>
 * <ol>
 * <li>oߎ(JEg_E[hłΎc莞)<br>
 *     00:00:00 Ƃ悤,::b̌`ŕ\.
 *
 * <li>w莞ԌoߎɃA[炷ǂ<br>
 *     炷ݒł&quot;Alarm&quot;ƂԂ̏
 *     \.
 *
 * <li>w莞ԌoߎɃbZ[W_CAO\邩ǂ<br>
 *     \ݒł&quot;Message&quot;ƂԂ̏
 *     \.
 *
 * <li>w莞ԌoߎɃfBXvC_ŕ\邩ǂ<br>
 *     _łݒł&quot;Blink&quot;ƂԂ̏
 *     \.
 * </ol>
 * </p>
 */
public class TimNormalDisplay extends Canvas implements TimDisplay{
	/** fBXvC̕ */
	protected int width;
	
	/** fBXvC̍ */
	protected int height;
	
	/** fBXvC̕F */
	protected Color fgColor;
	
	/** fBXvC̔wiF */
	protected Color bgColor;
	
	/** Ԃ̕\ɎgptHg */
	protected Font timeFont;
	
	/** Ԃ̏ɕ\郉x̃tHg */
	protected Font labelFont;
	
	/** Ԃ̕\ɎgptHg̏ */
	protected FontMetrics timeFontMetrics;
	
	/** Ԃ̏ɕ\郉x̃tHg */
	protected FontMetrics labelFontMetrics;
	
	/** A[炷ݒ̎ɕ\镶 */
	protected final String ALARM_STR   = "Alarm";
	
	/** bZ[W_CAO̕\sݒ̎ɕ\镶 */
	protected final String MESSAGE_STR = "Message";
	
	/** fBXvC̓_ŕ\sݒ̎ɕ\镶 */
	protected final String BLINK_STR   = "Blink";
	
	/**
	 * A[炷ǂ̐ݒ󋵂\镶.
	 * A[炷ݒ̎ɂ,<code>ALARM_STR</code>̓e
	 * . A[炳Ȃݒ̎͋󕶎񂪓.
	 */
	protected String alarmLabel   = "";
	
	/**
	 * bZ[W_CAO\邩ǂ̐ݒ󋵂\
	 * .
	 * bZ[W_CAO\ݒ̎ɂ,
	 * <code>MESSAGE_STR</code>̓e.
	 * bZ[W_CAO\Ȃݒ̎ɂ͋󕶎񂪓.
	 */
	protected String messageLabel = "";
	
	/**
	 * fBXvC̓_ŕ\sǂ̐ݒ󋵂\
	 * .
	 * fBXvC̓_ŕ\sݒ̎ɂ,
	 * <code>BLINK_STR</code>̓e.
	 * fBXvC̓_ŕ\sȂݒ̎ɂ͋󕶎񂪓.
	 */
	protected String blinkLabel   = "";
	
	/**
	 * A[炷ǂ̐ݒ󋵂\镶̕\ʒu.
	 */
	protected Point  alarmLabelPos;
	
	/**
	 * bZ[W_CAO\邩ǂ̐ݒ󋵂\
	 * ̕\ʒu.
	 */
	protected Point  messageLabelPos;
	
	/**
	 * fBXvC̓_ŕ\sǂ̐ݒ󋵂\镶
	 * ̕\ʒu.
	 */
	protected Point  blinkLabelPos;
	
	/** ݂̌oߎ(܂͎c莞)\ */
	protected String timeString = "00:00:00";
	
	/** ݂̌oߎ(܂͎c莞)\̕\ʒu */
	protected Point  timeStringPos;
	
	/**
	 * ItXN[C[W.
	 * `掞̃obt@ƂĎgp.
	 */
	protected Image offscreenImg;
	
	/**
	 * ItXN[C[W̃OtBbNXReLXg.
	 * ۂ̕`摀,̃OtBbNXReLXgɑ΂čs
	 * .
	 */
	protected Graphics offscreenG;
	
	/**
	 * fBXvC̓_ŕ\̐sIuWFNg.
	 */
	protected DisplayBlinker blinker;
	
	
	/**
	 * AvP[V̕W̃fBXvC𐶐.
	 */
	public TimNormalDisplay(){
		/* tHg̐ݒ */
		timeFont = new Font("SansSerif", Font.PLAIN, 40);
		labelFont = new Font("SansSerif", Font.PLAIN, 12);
		
		/* tHg̎擾 */
		timeFontMetrics = Toolkit.getDefaultToolkit().getFontMetrics(
			timeFont
		);
		
		labelFontMetrics = Toolkit.getDefaultToolkit().getFontMetrics(
			labelFont
		);
		
		
		/*
		 * fBXvC̃TCYݒ肷.
		 */
		 
		/* ԕ̕ */
		this.width  =  timeFontMetrics.stringWidth(timeString);
		
		/* ԕ̍ */
		this.height =  timeFontMetrics.getHeight();
		
		/* x̍ + 5 */
		this.height += labelFontMetrics.getHeight() + 5;
		
		
		/*
		 * exƎԕ̕\ʒuݒ肷.
		 */
		int labelX = 1; /* x\ʒuXW */
		int labelY = labelFontMetrics.getAscent(); /* YW */
		
		alarmLabelPos = new Point(labelX, labelY);
		
		labelX += labelFontMetrics.stringWidth(ALARM_STR) + 7;
		
		messageLabelPos = new Point(labelX, labelY);
		
		labelX += labelFontMetrics.stringWidth(MESSAGE_STR) + 7;
		
		blinkLabelPos = new Point(labelX, labelY);
		
		timeStringPos = new Point(
			0, labelY + 5 + timeFontMetrics.getAscent()
		);
		
		
		/*
		 * fBXvC̓_ŕ\̐sIuWFNg𐶐.
		 */
		blinker = new DisplayBlinker();
	}
	
	/**
	 * fBXvC̃TCYԂ.
	 *
	 * @return fBXvC̃TCY\<code>Dimension</code>
	 *         IuWFNg.
	 */
	public Dimension getPreferredSize(){
		return new Dimension(this.width, this.height);
	}
	
	/**
	 * fBXvC̍ŏTCYԂ.
	 * ۂɂ<code>getPreferredSize()</code>ƓlԂ.
	 *
	 * @return fBXvC̍ŏTCY\<code>Dimension</code>
	 *         IuWFNg.
	 */
	public Dimension getMinimumSize(){
		return getPreferredSize();
	}
	
	/**
	 * fBXvC̍ĕ`sɌĂ΂.
	 */
	public void update(Graphics g){
		paint(g);
	}
	
	/**
	 * ItXN[C[W𐶐.
	 */
	protected void createOffscreenImage(){
		offscreenImg = createImage(this.width, this.height);
		offscreenG   = offscreenImg.getGraphics();
	}
	
	/**
	 * ItXN[C[Wɕ`悳ĂeNA.
	 */
	protected void clearOffscreenImage(){
		offscreenG.setColor(getBackground());
		offscreenG.fillRect(0, 0, this.width, this.height);
		offscreenG.setColor(getForeground());
	}
	
	/**
	 * fBXvC̕`s.
	 */
	public void paint(Graphics g){
		if(offscreenImg == null){
			createOffscreenImage();
		}
		
		/* ItXN[C[WNA */
		clearOffscreenImage();
		
		/*
		 * ex̕\
		 */
		offscreenG.setFont(labelFont);
		
		offscreenG.drawString(
			alarmLabel, alarmLabelPos.x, alarmLabelPos.y
		);
		
		offscreenG.drawString(
			messageLabel, messageLabelPos.x, messageLabelPos.y
		);
		
		offscreenG.drawString(
			blinkLabel, blinkLabelPos.x, blinkLabelPos.y
		);
		
		/*
		 * Ԃ\
		 */
		offscreenG.setFont(timeFont);
		
		offscreenG.drawString(
			timeString, timeStringPos.x, timeStringPos.y
		);
		
		/*
		 * ȏ̑̓ItXN[ōŝ,ɂ̓e
		 * ۂ̃fBXvCɕ\.
		 */
		g.drawImage(offscreenImg, 0, 0, this);
	}
	
	/**
	 * w肳ꂽԂfBXvCɕ\.
	 *
	 * @param time \鎞.
	 *
	 * @see   TimTime
	 */
	public void displayTime(TimTime time){
		String hour, minute, second;
		
		if(time.get(TimTime.HOUR) > 99){
			return;
		}
		
		if(time.get(TimTime.HOUR) < 10){
			hour = "0" + time.get(TimTime.HOUR);
		}else{
			hour = String.valueOf(time.get(TimTime.HOUR));
		}
		
		if(time.get(TimTime.MINUTE) < 10){
			minute = "0" + time.get(TimTime.MINUTE);
		}else{
			minute = String.valueOf(time.get(TimTime.MINUTE));
		}
		
		if(time.get(TimTime.SECOND) < 10){
			second = "0" + time.get(TimTime.SECOND);
		}else{
			second = String.valueOf(time.get(TimTime.SECOND));
		}
		
		timeString = hour + ":" + minute + ":" + second;
		
		repaint();
	}
	
	/**
	 * AvP[VA[ɂʒmsݒɂȂĂ邩
	 * ǂCWP[^ON/OFFs.
	 *
	 * @param b CWP[^ONɂꍇtrue, OFFɂꍇ
	 *          false.
	 */
	public void setAlarmIndicator(boolean b){
		if(b == true){
			alarmLabel = ALARM_STR;
		}else{
			alarmLabel = "";
		}
		
		repaint();
	}
	
	/**
	 * AvP[VbZ[W_CAO\ɂʒms
	 * ݒɂȂĂ邩ǂCWP[^ON/OFFs.
	 *
	 * @param b CWP[^ONɂꍇtrue, OFFɂꍇ
	 *          false.
	 */
	public void setMessageIndicator(boolean b){
		if(b == true){
			messageLabel = MESSAGE_STR;
		}else{
			messageLabel = "";
		}
		
		repaint();
	}
	
	/**
	 * AvP[VfBXvC̓_ŕ\ɂʒmsݒ
	 * ɂȂĂ邩ǂCWP[^ON/OFFs.
	 *
	 * @param b CWP[^ONɂꍇtrue, OFFɂꍇ
	 *          false.
	 */
	public void setBlinkIndicator(boolean b){
		if(b == true){
			blinkLabel = BLINK_STR;
		}else{
			blinkLabel = "";
		}
		
		repaint();
	}
	
	/**
	 * fBXvC_ŕ\.
	 */
	public void blink(){
		if(! blinker.isAlive()){
			blinker.start();
		}else{
			blinker.restart();
		}
	}
	
	/**
	 * fBXvC̓_ŕ\𒆎~.
	 */
	public void stopBlinking(){
		if(blinker.isAlive()){
			blinker.pause();
		}
	}
	
	/**
	 * fBXvC𔽓]\.
	 */
	protected void reverse(){
		if(fgColor == null){ // fgColorݒ肳ĂȂꍇ
			/* ݂̑OiFƔwiF擾 */
			fgColor = getForeground();
			bgColor = getBackground();
			
			/*
			 * OiFƔwiF擾łȂꍇ,OiF,
			 * wiF𔒂ɂ.
			 */
			if(fgColor == null){
				fgColor = Color.black;
				bgColor = Color.white;
			}
		}
		
		/* OiFƔwiFւ */
		setForeground(bgColor);
		setBackground(fgColor);
		
		repaint();
	}
	
	/**
	 * ]\ĂfBXvCɖ߂.
	 */
	public void unreverse(){
		if(fgColor == null){ // fgColorݒ肳ĂȂꍇ
			/* OiF,wiF𔒂ɂ */
			setForeground(Color.black);
			setBackground(Color.white);
		}else{
			setForeground(fgColor);
			setBackground(bgColor);
		}
		
		repaint();
	}
	
	/**
	 * fBXvC̓_ŕ\̐sIuWFNg̃NX.
	 */
	class DisplayBlinker extends Thread{
		/* _ŕ\̊Ԋu */
		private final long INTERVAL = 400;
		
		/**
		 * fBXvC̓_ŕ\̐sIuWFNg𐶐.
		 */
		DisplayBlinker(){
		}
		
		/**
		 * fBXvC_ŕ\.
		 */
		public void run(){
			while(true){
				reverse(); /* ]\ */
				
				try{
					sleep(INTERVAL);
				}catch(InterruptedException e){
					/* Ȃ */
				}
				
				unreverse(); /* ɖ߂ */
				
				try{
					sleep(INTERVAL);
				}catch(InterruptedException e){
					/* Ȃ */
				}
			}
		}
		
		/**
		 * fBXvC̓_ŕ\ꎞ~.
		 */
		public void pause(){
			unreverse();
			suspend();
		}
		
		/**
		 * fBXvC̓_ŕ\ĊJ.
		 */
		public void restart(){
			resume();
		}
	}
}